﻿using Syncfusion.DocIO.DLS;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace CreateWordSample
{
    public partial class CreateWord : Form
    {
        public CreateWord()
        {
            InitializeComponent();
        }
        #region Create Word document
        private void button1_Click(object sender, EventArgs e)
        {
            //Loads the template document
            using (WordDocument document = new WordDocument(@"..\..\Data\Template.docx"))
            {
                WParagraph paragraph = null;
                WTextBody textBody = null;
                #region Finds the index of the particular text paragraph.
                //Finds the first occurrence of a particular text in the document
                TextSelection selection = document.Find("PlaceHolder1", false, true);
                if (selection != null)
                {
                    //Gets the found text as single text range
                    WTextRange textRange = selection.GetAsOneRange();
                    //Gets the owner paragraph of found text
                    paragraph = textRange.OwnerParagraph;
                    textBody = paragraph.OwnerTextBody;
                    //Gets the index of the particular paragraph in the document.
                    int index = textBody.ChildEntities.IndexOf(paragraph);
                }
                #endregion
                #region Finds the index of the bookmark paragraph.
                //Gets the bookmark instance by using FindByName method of BookmarkCollection with bookmark name
                Bookmark bookmark = document.Bookmarks.FindByName("Northwind");
                if (bookmark != null)
                {
                    //Gets the owner paragraph of bookmark
                    paragraph = bookmark.BookmarkStart.OwnerParagraph;
                    int index = textBody.ChildEntities.IndexOf(paragraph);
                }
                #endregion
                //Saves the Word document
                document.Save("Result.docx");
            }

            #region View the Workbook
            //Message box confirmation to view the created document
            if (MessageBox.Show("Do you want to view the Word document?", "Word document has been created",
                MessageBoxButtons.YesNo, MessageBoxIcon.Information)
                == DialogResult.Yes)
            {
                try
                {
                    //Launching the Word file using the default Application.[Microsoft Word Or Free Word viewer]
                    System.Diagnostics.Process.Start("Result.docx");

                    //Exit
                    Close();
                }
                catch (Win32Exception ex)
                {
                    MessageBox.Show("MS Word is not installed in this system");
                    Console.WriteLine(ex.ToString());
                }
            }
            else
                Close();
            #endregion
        }
        #endregion
    }
}
